﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;

namespace UltraGanttViewScroll
{
	public partial class Form1 : Form
	{
		private DateTime visibleRangeStart;
		private DateTime visibleRangeEnd;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			var project = ultraGanttView1.CalendarInfo.Projects.Add("Project 1", DateTime.Today.AddDays(-7));
			var task = ultraGanttView1.CalendarInfo.Tasks.Add(TimeSpan.FromDays(21), "Task1");
			task.Project = project;
			ultraGanttView1.Project = project;
		}

		private void ultraGanttView1_TimelineVisibleDateTimeRangeChanged(object sender, VisibleDateTimeRangeChangedEventArgs e)
		{
			if (e.Reason == VisibleDateTimeRangeChangedReason.ScrollPosition)
			{
				// Disable this event so modifying the visible range doesn't fire this event again.
				ultraGanttView1.EventManager.SetEnabled(Infragistics.Win.UltraWinGanttView.GanttViewEventIds.TimelineVisibleDateTimeRangeChanged, false);
				if (e.VisibleDateTimeRange.StartDateTime < visibleRangeStart)
				{
					// User scrolled left.
					if (e.VisibleDateTimeRange.StartDateTime < ultraGanttView1.Project.StartDate)
					{
						ultraGanttView1.EnsureDateTimeVisible(ultraGanttView1.Project.StartDate, true);
					}
				}

				if (e.VisibleDateTimeRange.EndDateTime > visibleRangeEnd)
				{
					// User scrolled right.
					DateTime projectEnd = ultraGanttView1.Project.StartDate;
					//foreach (Infragistics.Win.UltraWinSchedule.Task task in ultraGanttView1.Project.Tasks)
					for (int i = 0; i < ultraGanttView1.Project.Tasks.Count; i++)
					{
						var task = ultraGanttView1.Project.Tasks[i];
						if (task.EndDateTimeResolved > projectEnd)
						{
							projectEnd = task.EndDateTimeResolved;
						}
					}
					if (e.VisibleDateTimeRange.EndDateTime > projectEnd)
					{
						DateTime firstDate = projectEnd.Subtract(e.VisibleDateTimeRange.Range.Subtract(ultraGanttView1.TimelineSettings.PrimaryInterval.NormalSpan));
						ultraGanttView1.EnsureDateTimeVisible(firstDate, true);
					}
				}
				// Re-enable the event.
				ultraGanttView1.EventManager.SetEnabled(Infragistics.Win.UltraWinGanttView.GanttViewEventIds.TimelineVisibleDateTimeRangeChanged, true);
				visibleRangeStart = ultraGanttView1.TimelineSettings.VisibleDateTimeRange.StartDateTime;
				visibleRangeEnd = ultraGanttView1.TimelineSettings.VisibleDateTimeRange.EndDateTime;
			}
		}

		private void Form1_Activated(object sender, EventArgs e)
		{
			visibleRangeStart = ultraGanttView1.TimelineSettings.VisibleDateTimeRange.StartDateTime;
			visibleRangeEnd = ultraGanttView1.TimelineSettings.VisibleDateTimeRange.EndDateTime;
		}
	}
}
